<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Title</title>
</head>
<body>
<p>Чтобы добавить поддержку баз данных необходимо сделать следующие действия</p>
<ul style="list-style-type: circle;">
    <li>Добавить зависимости в pom.xml</li>
</ul>
<pre class="language-markup"><code>&lt;dependency&gt;
    &lt;groupId&gt;org.springframework.boot&lt;/groupId&gt;
    &lt;artifactId&gt;spring-boot-starter-data-r2dbc&lt;/artifactId&gt;
&lt;/dependency&gt;

&lt;dependency&gt;
    &lt;groupId&gt;com.h2database&lt;/groupId&gt;
    &lt;artifactId&gt;h2&lt;/artifactId&gt;
    &lt;scope&gt;runtime&lt;/scope&gt;
&lt;/dependency&gt;

&lt;dependency&gt;
    &lt;groupId&gt;io.r2dbc&lt;/groupId&gt;
    &lt;artifactId&gt;r2dbc-h2&lt;/artifactId&gt;
    &lt;scope&gt;runtime&lt;/scope&gt;
&lt;/dependency&gt;</code></pre>
<ul style="list-style-type: circle;">
    <li>Добавьте POJO класс, который 1 в 1 соответсвует полям в таблице базы данных</li>
</ul>
<pre class="language-java"><code>public record AddressBook(@Id Long id, String firstName, String lastName, String phone, LocalDate birthday) {
}</code></pre>
<ul style="list-style-type: circle;">
    <li>Добавьте интерфейс, который унаследует интерфейс <em>ReactiveCrudRepository</em></li>
</ul>
<p>В качестве первого шаблонного параметра должен быть POJO класс, созданный на предыдущей стадии</p>
<p>В качестве второго - тип первичного ключа у этого POJO класса</p>
<pre class="language-java"><code>public interface AddressBookRepository extends ReactiveCrudRepository&lt;AddressBook, Long&gt; {
}</code></pre>
<ul style="list-style-type: circle;">
    <li>Добавьте интерфейс repository внутрь сервиса, в которой будете вызывать базу данных</li>
</ul>
<p>В нашем случае, это AddressBookController</p>
<p>Добавлять зависимость рекомендуется через конструктор</p>
<pre class="language-java"><code>@RestController
public class AddressBookController {
    final AddressBookRepository repository;

    @Autowired
    public AddressBookController(AddressBookRepository repository) {
        this.repository = repository;
    }
}</code></pre>
<ul style="list-style-type: circle;">
    <li>Обратитесь к repository, чтобы поработать с базой данных</li>
</ul>
<pre class="language-java"><code>@RestController
public class AddressBookController {
    final AddressBookRepository repository;

    @Autowired
    public AddressBookController(AddressBookRepository repository) {
        this.repository = repository;
    }

    @GetMapping("addressbooks")
    public Flux&lt;AddressBook&gt; getAddressBookPage() {
        return repository.findAll();
    }
}</code></pre>
<p>&nbsp;</p>
<p>Готово, теперь вы можете обратиться к GET методу <em>addressbooks</em> и получить все записи из базы данных</p>
<p>&nbsp;</p>
<p>Теперь попробуйте реализовать эту логику самостоятельно</p>
<p>&nbsp;</p>
<pre class="language-bash"><code>docker container run busybox</code></pre>
<table>
    <colgroup>
        <col style="background-color: #0f0"/>
        <col span="2"/>
    </colgroup>
    <tr>
        <th>Company</th>
        <th>Contact</th>
        <th>Country</th>
    </tr>
    <tr>
        <td>Alfreds Futterkiste</td>
        <td>Maria Anders</td>
        <td>Germany</td>
    </tr>
    <tr>
        <td>Centro comercial Moctezuma</td>
        <td>Francisco Chang</td>
        <td>Mexico</td>
    </tr>
</table>
<table style="border-collapse: collapse; width: 100%; border-style: solid; border-color: rgba(0, 0, 0, 0.1); height: 54px;"
       border="1">
    <tbody>
    <tr style="height: 18px;">
        <td style="width: 33.141605%; height: 18px;">1</td>
        <td style="width: 33.141605%; height: 18px;">2</td>
        <td style="width: 33.141605%; height: 18px;">3</td>
    </tr>
    <tr style="height: 18px;">
        <td style="width: 33.141605%; height: 18px;">4</td>
        <td style="width: 33.141605%; height: 18px;">5</td>
        <td style="width: 33.141605%; height: 18px;">6</td>
    </tr>
    <tr style="height: 18px;">
        <td style="width: 33.141605%; height: 18px;">7</td>
        <td style="width: 33.141605%; height: 18px;">8</td>
        <td style="width: 33.141605%; height: 18px;">9</td>
    </tr>
    </tbody>
</table>

<pre class="language-yaml"><code>kind: Pod
apiVersion: v1
metadata:
  name: POD-NAME
  labels:
    app: SELECTOR
spec:
  containers:
    - name: CONTAINER-NAME
      image: IMAGE-NAME
      ports:
        - name: http
          containerPort: 8080</code></pre>
</body>
</html>